#!/usr/bin/perl

#################################
#                               #
#  All right reserved (C) 2010  #
#                               #
#   script was written by Axl   #
#                               #
#################################

use strict;
use warnings;

my ($inifile, $section, $key) = @ARGV;
my (@lines);
my ($line);

if ($inifile eq "--help") {
    print "Usage:\nfor ini file: get_key_value.cgi filename section key\nfor config file: get_key_value.cgi filename key\n";
    exit;
}

open(STDIN, "<$inifile") || die "Error read file $inifile, for help: parse_ini.cgi --help\n";
while( <STDIN> ) {
	s/\r\n/\n/;	    # remove windows eol
	s/#.*//;            # ignore comments by erasing them
	next if /^(\s)*$/;  # skip blank lines
	chomp;              # remove trailing newline characters
	push @lines, $_;    # push the data line onto the array
}
close(STDIN);

if (@ARGV == 3)
{ #for ini file
  my ($in_section) = 0;
  foreach $line (@lines) {
    if ($line =~ /^\[$section\]$/) {
        $in_section = 1;
        next;
    }
    if ($line =~ /^\[/) {
        $in_section = 0;
        next;
    }
    if ($in_section and $line =~ /^$key\s*=\s*(.*)$/) {
        print "$1";
        last;
    }
  }
}
else
{ #for config file
  foreach $line (@lines) {
    if ($line =~ /^$section\s*=\s*(.*)$/) {
        print "$1";
        last;
    }
  }
}

