#!/usr/bin/perl
#================================================================================
# (C)2013 Axl. All rights reserved.
# Title       : Synod
# Version     : V1.7
# Author      : dMajo (http://forum.synology.com/enu/memberlist.php?mode=viewprofile&u=69661)
# Description : Local mirror for nod32 updates deployment
# Dependencies: none
# Usage       : install the .spk from http://spk.synologyitalia.com
#================================================================================
# Version history:
# 2013       - 1.6b written by Axl (original release on diskstation.ru)
# 2014.09.05 - 1.6m multilingual package, script revised by(dMajo) &(Burghy86)
# 2014.09.09 - 1.7 access only with login in dsm(burghy86)&(S1m0n3)
#================================================================================

use CGI qw(param);
use FindBin qw/$Bin/;

my (@lines);
my ($line);
$version = "1.7";
$lastupdate="$Bin/lastupdate.info";
$updateconf="$Bin/update.conf";

print "Content-type: text/html\; charset=utf-8\n\n";

if (index($ENV{HTTP_ACCEPT_LANGUAGE},"ru") == 0)
{
	$lang = "RU";
	$lang_conftitle = "настройки сервера обновлений";
	$lang_updStatTitle = "статистика";
	$lang_updUrl = "сервер обновлений";
	$lang_updUrlDesc = "укажите адрес сервера обновлений eset";
	$lang_updLang = "Языковые версии пакетов";
	$lang_updTime = "время проверки";
	$lang_updLast = "последнее обновление";
	$lang_updErr = "ошибка обновления";
	$lang_updSchedTitle = "Расписание обновлений";
	$lang_dtTime = "время";
	$lang_dtMon = "понедельник";
	$lang_dtTue = "вторник";
	$lang_dtWed = "среда";
	$lang_dtThu = "четверг";
	$lang_dtFri = "пятница";
	$lang_dtSat = "суббота";
	$lang_dtSun = "воскресенье";
	$lang_dbCheck = "последняя проверка баз";
	$lang_dbSize = "объем базы";
	$lang_dbVer = "текуща база";
	$lang_nodUser = "имя пользователя";
	$lang_nodUserDesc = "укажите имя пользователя или оставьте пустым";
	$lang_nodPsw = "пароль";
	$lang_nodPswDesc = "укажите пароль или оставьте пустым";
	$lang_nodPswShow = "показать пароль";
	$lang_locConfTitle = "настройки локального зеркала";
	$lang_locFolder = "путь к базам";
	$lang_locFolderDesc = "укажите путь, где будут храниться локальные базы";
	$lang_locUser = "имя пользователя";
	$lang_locUserDesc = "укажите имя пользователя для локального зеркала";
	$lang_locPsw = "пароль";
	$lang_locPswDesc = "укажите пароль для локального зеркала";
	$lang_locPswShow = "показать пароль";
	$lang_cmdSave = "Сохранить нстройки";
	$lang_cmdClear = "Очистить базы";
	$lang_cmdUpdate = "Обновить сейчас";
	$Lang_locConfTitle2 = "Местные члены представить:";
	$Lang_locdel = "Удалить пользователя";
	$Lang_notlocuser = "Ни один пользователь не вошел";
}
elsif (index($ENV{HTTP_ACCEPT_LANGUAGE},"it") == 0)
{
	$lang = "IT";
	$lang_conftitle = "Configurazione Server Aggiornamento";
	$lang_updStatTitle = "Statistiche";
	$lang_updUrl = "Indirizzo URL server aggiornamenti";
	$lang_updUrlDesc = "specify the address of the update server eset";
	$lang_updLang = "Lingua degli aggiornamenti da scaricare";
	$lang_updTime = "Durata aggiornamento";
	$lang_updLast = "Ultimo Aggiornamento";
	$lang_updErr = "Errore di aggiornamento";
	$lang_updSchedTitle = "Schedulazione aggiornamenti";
	$lang_dtTime = "ora";
	$lang_dtMon = "Lunedì";
	$lang_dtTue = "Martedì";
	$lang_dtWed = "Mercoledì";
	$lang_dtThu = "Giovedì";
	$lang_dtFri = "Venerdì";
	$lang_dtSat = "Sabato";
	$lang_dtSun = "Domenica";
	$lang_dbCheck = "Controllo Database";
	$lang_dbSize = "Dimensione Database";
	$lang_dbVer = "Versione Database";
	$lang_nodUser = "Nome utente";
	$lang_nodUserDesc = "Inserire lo username nod oppure lasciare vuoto il campo";
	$lang_nodPsw = "Password";
	$lang_nodPswDesc = "Inserire la password nod oppure lasciare vuoto il campo";
	$lang_nodPswShow = "Mostra Password";
	$lang_locConfTitle = "Impostazioni Mirror Locale";
	$lang_locFolder = "Cartella locale";
	$lang_locFolderDesc = "Percorso locale degli aggiornamenti";
	$lang_locUser = "Aggiungi Nome utente";
	$lang_locUserDesc = "Inserire lo username locale per gli aggiornamenti";
	$lang_locPsw = "Inserisci Password";
	$lang_locPswDesc = "Inserire la password dell'utente locale";
	$lang_locPswShow = "Mostra Password";
	$lang_cmdSave = "Salva Impostazioni";
	$lang_cmdClear = "Svuota I Campi";
	$lang_cmdUpdate = "Aggiorna Ora";
        $lang_login_error = "accesso richiesto";
	$lang_login_error_text = "per visualizzare questa pagina bisogna essere loggati come admin";
        $lang_useragent = "synod agent";
	$lang_nodagentDesc = "Stringa con cui si presenta synod al server di Eset (NON MODIFICATE SE NON SIETE ESPERTI)";
	$lang_locConfTitle2 = "Utenti Locali presenti:";
	$lang_locdel = "Cancella utente";
	$lang_notlocuser = "Nessun utente inserito";

}
elsif (index($ENV{HTTP_ACCEPT_LANGUAGE},"es") == 0)
{
	$lang = "ES";
	$lang_conftitle = "Configuración del servidor de actualizaciones";
	$lang_updStatTitle = "Estadísticas";
	$lang_updUrl = "Update's Server URL address";
	$lang_updUrlDesc = "Especifique la dirección del servidor de actualizaciones de ESET";
	$lang_updLang = "Idiomas descarga de actualización";
	$lang_updTime = "actualización duración ";
	$lang_updLast = "Última actualización";
	$lang_updErr = "actualización de error";
	$lang_updSched = "Programador de actualizaciones";
	$lang_dtTime = "tiempo";
	$lang_dtMon = "Lunes";
	$lang_dtTue = "Martes";
	$lang_dtWed = "Miércoles";
	$lang_dtThu = "Jueves";
	$lang_dtFri = "Viernes";
	$lang_dtSat = "Sábado";
	$lang_dtSun = "Domingo";
	$lang_dbCheck = "verificación de base de datos";
	$lang_dbSize = "Tamaño de base de datos";
	$lang_dbVer = "La versión de base de datos";
	$lang_nodUser = "Nombre de usuario";
	$lang_nodUserDesc = "Introduce el nombre de usuario o guiño deje el campo vacío";
	$lang_nodPsw = "Contraseña";
	$lang_nodPswDesc = "Inserte el visto bueno contraseña o deje el campo vacío";
	$lang_nodPswShow = "Mostrar contraseña";
	$lang_locConfTitle = "Configuración de la réplica local";
	$lang_locFolder = "Carpeta local";
	$lang_locFolderDesc = "Ruta de acceso local al repositorio de actualizaciones";
	$lang_locUser = "Nombre de usuario";
	$lang_locUserDesc = "Introduzca el nombre de usuario locales";
	$lang_locPsw = "Contraseña";
	$lang_locPswDesc = "Introduzca la contraseña local";
	$lang_locPswShow = "Mostrar contraseña";
	$lang_cmdSave = "Guardar configuración";
	$lang_cmdClear = "Borrar campos";
	$lang_cmdUpdate = "Actualizar ahora";
	$lang_login_error = "Inicio de sesión obligatorio";
	$lang_login_error_text = "Por favor, ingresa como admin en primer lugar, antes de usar esta página web";
	$Lang_locConfTitle2 = "Usuarios locales presentan:";
	$Lang_locdel = "Eliminar usuario";
	$Lang_notlocuser = "No hay usuario introdujo";
}
elsif (index($ENV{HTTP_ACCEPT_LANGUAGE},"fr") == 0)
{
	$lang = "FR";
	$lang_conftitle = "Configuration du serveur Mises à jour";
	$lang_updStatTitle = "Statistiques";
	$lang_updUrl = "Update's Server URL address";
	$lang_updUrlDesc = "spécifient l'adresse du serveur de mise à jour eset";
	$lang_updLang = "Update's download language";
	$lang_updTime = "durée mise à jour";
	$lang_updLast = "Mise à jour";
	$lang_updErr = "Erreur de mise à jour";
	$lang_updSchedTitle = "Mises à jour Schedulerr";
	$lang_dtTime = "trois";
	$lang_dtMon = "Lundi";
	$lang_dtTue = "mardi";
	$lang_dtWed = "mercredi";
	$lang_dtThu = "vendredi";
	$lang_dtFri = "Friday";
	$lang_dtSat = "samedi";
	$lang_dtSun = "dimanche";
	$lang_dbCheck = "vérification de la base de données";
	$lang_dbSize = "taille de base de données";
	$lang_dbVer = "version de base de données";
	$lang_nodUser = "Nom d'utilisateur";
	$lang_nodUserDesc = "Insérez le feu vert nom d'utilisateur o laisser le champ vide";
	$lang_nodPsw = "Mot de passe";
	$lang_nodPswDesc = "Insérez le feu vert de passe o laisser le champ vide";
	$lang_nodPswShow = "Afficher le mot de passe";
	$lang_locConfTitle = "Paramètres miroir local";
	$lang_locFolder = "Dossier local";
	$lang_locFolderDesc = "Chemin d'accès local à la mise à jour du référentiel";
	$lang_locUser = "Nom d'utilisateur";
	$lang_locUserDesc = "Insérez le nom d'utilisateur local";
	$lang_locPsw = "Mot de passe";
	$lang_locPswDesc = "Insérez le mot de passe local";
	$lang_locPswShow = "Afficher le mot de passe";
	$lang_cmdSave = "Paramètres d'enregistrement";
	$lang_cmdClear = "Champs claires";
	$lang_cmdUpdate = "Mettre à jour maintenant";
	$lang_login_error = "Connexion requise";
	$lang_login_error_text = "S'il vous plaît vous connecter en tant qu'administrateur en premier lieu, avant d'utiliser cette page";
	$Lang_locConfTitle2 = "membres locaux présenter:";
	$Lang_locdel = "Supprimer un utilisateur de";
	$Lang_notlocuser = "Aucun utilisateur entré";
}
elsif (index($ENV{HTTP_ACCEPT_LANGUAGE},"de") == 0)
{
	$lang = "DE";
	$lang_conftitle = "Updates-Server-Konfiguration";
	$lang_updStatTitle = "Statistik";
	$lang_updUrl = "Update der Server-URL-Adresse";
	$lang_updUrlDesc = "geben Sie die Adresse des Update-Servers ESET";
	$lang_updLang = "Update Download-Sprache";
	$lang_updTime = "Durata aggiornamento";
	$lang_updLast = "Letzte Aktualisierung";
	$lang_updErr = "Update-Fehler";
	$lang_updSchedTitle = "Updates Scheduler";
	$lang_dtTime = "Zeit";
	$lang_dtMon = "Montag";
	$lang_dtTue = "Tuesday";
	$lang_dtWed = "Mittwoch";
	$lang_dtThu = "Donnerstag";
	$lang_dtFri = "Freitag";
	$lang_dtSat = "Samstag";
	$lang_dtSun = "Sonntag";
	$lang_dbCheck = "Datenbank";
	$lang_dbSize = "Datenbankgröße";
	$lang_dbVer = "Datenbank-Version";
	$lang_nodUser = "Username";
	$lang_nodUserDesc = "Bitte geben Sie den Benutzernamen Nicken o lassen Sie das Feld leer";
	$lang_nodPsw = "Passwort";
	$lang_nodPswDesc = "Bitte geben Sie den Passwort Nicken o lassen Sie das Feld leer";
	$lang_nodPswShow = "Kennwort anzeigen";
	$lang_locConfTitle = "Local Mirror Einstellungen";
	$lang_locFolder = "Lokale Ordner";
	$lang_locFolderDesc = "Lokale Pfad zu dem Repository Updates";
	$lang_locUser = "Username";
	$lang_locUserDesc = "Legen Sie die lokalen Benutzernamen";
	$lang_locPsw = "Passwort";
	$lang_locPswDesc = "Legen Sie die lokale Passwort";
	$lang_locPswShow = "Kennwort anzeigen";
	$lang_cmdSave = "Einstellungen speichern";
	$lang_cmdClear = "Felder löschen";
	$lang_cmdUpdate = "Jetzt aktualisieren";
	$lang_login_error = "Anmeldung erforderlich";
	$lang_login_error_text = "Bitte loggen Sie sich zuerst als Administrator, bevor Sie diese Webseite";
	$Lang_locConfTitle2 = "Lokale Mitglieder präsentieren:";
	$Lang_locdel = "Benutzer löschen";
	$Lang_notlocuser = "Kein Benutzer eingegeben";
}
else
{
	$lang = "EN";
	$lang_conftitle = "Updates server Configuration";
	$lang_updStatTitle = "Statistics";
	$lang_updUrl = "Update's Server URL address";
	$lang_updUrlDesc = "specify the address of the update server eset";
	$lang_updLang = "Update's download language";
	$lang_updTime = "Durata aggiornamento";
	$lang_updLast = "Last update";
	$lang_updErr = "Update error";
	$lang_updSchedTitle = "Updates Scheduler";
	$lang_dtTime = "time";
	$lang_dtMon = "Monday";
	$lang_dtTue = "Tuesday";
	$lang_dtWed = "Wednesday";
	$lang_dtThu = "Thursday";
	$lang_dtFri = "Friday";
	$lang_dtSat = "Saturday";
	$lang_dtSun = "Sunday";
	$lang_dbCheck = "Database check";
	$lang_dbSize = "Database size";
	$lang_dbVer = "Database version";
	$lang_nodUser = "Username";
	$lang_nodUserDesc = "Insert the nod username o leave the field empty";
	$lang_nodPsw = "Password";
	$lang_nodPswDesc = "Insert the nod password o leave the field empty";
	$lang_nodPswShow = "Show Password";
	$lang_locConfTitle = "Local Mirror Settings";
	$lang_locFolder = "Local Folder";
	$lang_locFolderDesc = "Local path to the updates repository";
	$lang_locUser = "Add Username";
	$lang_locUserDesc = "Insert the local username";
	$lang_locPsw = "add Password";
	$lang_locPswDesc = "Insert the local password";
	$lang_locPswShow = "Show Password";
	$lang_cmdSave = "Save settings";
	$lang_cmdClear = "Clear fields";
	$lang_cmdUpdate = "Update Now";
	$lang_login_error = "Login Required";
	$lang_login_error_text = "Please login as admin first, before using this webpage";
        $lang_useragent = "synod agent";
	$lang_nodagentDesc = "Stringa con cui si presenta synod al server di Eset (NON MODIFICATE SE NON SIETE ESPERTI)";
	$lang_locConfTitle2 = "Local Members present:";
	$lang_locdel = "Delete user";
	$lang_notlocuser = "No user entered";

}
	$lang_apptitle = "Synod Local Mirror For Eset NOD32 ".$version." (".$lang.")";
	$lang_enu = "English";
	$lang_bgr = "Български";
	$lang_hun = "Magyar";
	$lang_nld = "Nederlands";
	$lang_dan = "Dansk";
	$lang_esn = "Español";
	$lang_ita = "Italiano";
	$lang_chs = "中国";
	$lang_deu = "Deutsch";
	$lang_nor = "Norsk";
	$lang_plk = "Polskie";
	$lang_ptb = "Português";
	$lang_rom = "Română";
	$lang_rus = "Русский";
	$lang_sky = "Slovenský";
	$lang_slv = "Slovenščina";
	$lang_cht = "中國";
	$lang_trk = "Türk";
	$lang_ukr = "Український";
	$lang_fin = "Suomi";
	$lang_fra = "Français";
	$lang_hrv = "Hrvatski";
	$lang_csy = "České";
	$lang_sve = "Svedese";


	
if (-e $lastupdate) {
open(STDIN, "<$lastupdate") || die;
while( <STDIN> ) {
	s/\r\n/\n/;
	s/#.*//;
	next if /^(\s)*$/;
	chomp;
	push @lines, $_;
}
close(STDIN);
$nod_upbase=get_key("upbase");
$nod_update=get_key("update");
$nod_ubdtime=get_key("time");
$nod_version=get_key("version");
$nod_error=get_key("error");
chomp($nod_error);
if ($nod_error ne "") {$nod_error= "  <tr>\n    <td><span class=\"normal_font\">".$lang_updErr." </span></td>\n    <td><a class=\"bold_font\">$nod_error</a></td>\n  </tr>";}
@vers=split(/ /,$nod_version);
}

if (-e $updateconf) {
open(STDIN, "<$updateconf") || die;
while( <STDIN> ) {
	s/\r\n/\n/;
	s/#.*//;
	next if /^(\s)*$/;
	chomp;
	push @lines, $_;
}
close(STDIN);
$nod_bases=get_key("bases");
$nod_url=get_key("url");
$nod_user=get_key("user");
$nod_passwd=get_key("passwd");
$usr_name_local=get_key("user_local");
$usr_passwd_local=get_key("passwd_local");
$languages=get_key("languages");
@weekdays=split(/\|/,get_key("weekdays"));
$hours=get_key("hours");
chomp($hours);
$minutes=get_key("minutes");
$nod_user_agent=get_key("user_agent");
}


my  @langarr = (
	["enu", $lang_enu, ""],
	["bgr", $lang_bgr, ""],
	["hun", $lang_hun, ""],
	["nld", $lang_nld, ""],
	["dan", $lang_dan, ""],
	["esn", $lang_esn, ""],
	["ita", $lang_ita, ""],
	["chs", $lang_chs, ""],
	["deu", $lang_deu, ""],
	["nor", $lang_nor, ""],
	["plk", $lang_plk, ""],
	["ptb", $lang_ptb, ""],
	["rom", $lang_rom, ""],
	["rus", $lang_rus, ""],
	["sky", $lang_sky, ""],
	["slv", $lang_slv, ""],
	["cht", $lang_cht, ""],
	["trk", $lang_trk, ""],
	["ukr", $lang_ukr, ""],
	["fin", $lang_fin, ""],
	["fra", $lang_fra, ""],
	["hrv", $lang_hrv, ""],
	["csy", $lang_csy, ""],
	["sve", $lang_sve, ""]
);
	my $jslangarr;
		for(my $i=0; $i<@langarr; $i++) {
			if (!(grep /$langarr[$i][0]/, $languages)) { $langarr[$i][2]='checked="checked"';}
			$jslangarr = "$jslangarr\"$langarr[$i][0]\",";
		}

my  @weekgarr = (
	[$lang_dtSun, ""],
	[$lang_dtMon, ""],
	[$lang_dtTue, ""],
	[$lang_dtWed, ""],
	[$lang_dtThu, ""],
	[$lang_dtFri, ""],
	[$lang_dtSat, ""]
);
	for(my $i=0; $i<@weekgarr; $i++) {
		if ($weekdays[$i]==1) { $weekgarr[$i][1]='checked="checked"';}
	}

# HTML and javascript stuff

print  <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>$lang_apptitle</title>
  <link rel="stylesheet" href="jquery-ui.css" />
  <script src="jquery-1.9.1.js"></script>
  <script src="jquery-ui.js"></script>

  <style type="text/css">
   HTML {
    height: 100%;
   }
   BODY {
	background:
	url('images/man.png') right bottom no-repeat;
	background-attachment: fixed;
	margin-right: 150px;
	font-family: Arial, Helvetica, sans-serif;
	color: #666;
	height: 16px;
   }
  .big_font {
	font-size: 18px;
	font-weight: 700;
   }
  .normal_font {
	font-size: 12px;
	font-weight: 300;
   }
  .bold_font {
	font-size: 12px;
	font-weight: 300;
	color:#333;
	font-weight:bold;
   }
   HR {
    border: none;
    color: #666;
    background-color: #666;
    height: 1px;
   }
   INPUT, SELECT {
	font:11px Verdana;
	width:250px;
	height:18px;
	background-color:#FFF;
	border-color:#CCC;
	border-width:1px;
	border-style:solid;
	color:#000;
   }
   .passwd {
	font:11px Verdana;
	color:#000;
	margin-left:10px;
	padding:3px;
   }
   .checkbox {
	width:12px;
	height:12px;
   }
  .ui-progressbar {
    position: relative;
    width:300px;
    height:16px;
  }
  .progress-label {
    position: absolute;
    left: 50%;
    top: 1px;
    text-shadow: 1px 1px 0 #fff;
    font-size: 10px;
  }
   
</style>


EOF

use CGI;
my $q = CGI->new();
my $usrtodelete = $q->param('usr_del');
if ($usrtodelete ne "") {

if ( ! open ( HTPASSWD , "$Bin/.htpasswd" ) )
{
   die ( "Non è stato possibile aprire il file : $!" ); 
} 



if ( ! open ( TEMP , ">$Bin/.htpasswd_temp" ) )
{
   die ( "Non è stato possibile aprire il file : $!" ); 
} 



while ( $linea = <HTPASSWD> )
{
   @username = split ( ":" , $linea );
   
 
  if (@username[0] ne $usrtodelete )
  {
   print TEMP "$linea";
  }

  }
  close (HTPASSWD);
  close (TEMP);
  
 unlink ("$Bin/.htpasswd");
 use File::Copy qw(move);
 move "$Bin/.htpasswd_temp", "$Bin/.htpasswd";
 
 print "<script type='text/javascript'>window.location='index.cgi'</script>"
 }
 



print  <<EOF;

        <script type="text/javascript" language="javascript">

            var http_request = false;

            function makeRequest(url) {

                http_request = false;

				var langarr = [$jslangarr]


				var poststr = 'url=' +
				  encodeURI(document.forms['options'].elements['nod_url'].value) +
				  '&amp;user_name=' +
				  encodeURI(document.forms['options'].elements['nod_user_name'].value) +
				  '&amp;usr_passwd=' +
				  encodeURI(document.forms['options'].elements['nod_usr_passwd'].value) +
				  '&amp;base=' +
				  encodeURI(document.forms['options'].elements['nod_base'].value) +
				  '&amp;usr_name_local=' +
				  encodeURI(document.forms['options'].elements['nod_usr_name_local'].value) +
				  '&amp;usr_passwd_local=' +
				  encodeURI(document.forms['options'].elements['nod_usr_passwd_local'].value) +
				  '&amp;language=';

				for (var i=0; i < document.forms['options'].elements['lang[]'].length; i++) {if (!(document.forms['options'].elements['lang[]'][i].checked)) {poststr = poststr + encodeURI('/'+langarr[i]+'/d|'); }}
				poststr = poststr + '&amp;weekdays=';
				for (var i=0; i < document.forms['options'].elements['week[]'].length; i++) {
					if (document.forms['options'].elements['week[]'][i].checked) {
						poststr = poststr + encodeURI('1|');
					} else {
						poststr = poststr + encodeURI('0|');
					}
				}
				
				poststr = poststr+'&amp;hours='+document.forms['options'].elements['hours'].value;
				poststr = poststr+'&amp;minutes='+document.forms['options'].elements['minutes'].value;

                if (window.XMLHttpRequest) { // Mozilla, Safari,...
                    http_request = new XMLHttpRequest();
                    if (http_request.overrideMimeType) {
                        http_request.overrideMimeType('text/xml');
                    }
                } else if (window.ActiveXObject) { // IE
                    try {
                        http_request = new ActiveXObject("Msxml2.XMLHTTP");
                    } catch (e) {
                        try {
                        http_request = new ActiveXObject("Microsoft.XMLHTTP");
                        } catch (e) {}
                    }
                }

                if (!http_request) {
                    alert('Giving up :( Cannot create an XMLHTTP instance');
                    return false;
                }
                http_request.onreadystatechange = alertContents;
                http_request.open('POST', url, true);
				http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                http_request.send(poststr);

            }

            function alertContents() {

                if (http_request.readyState == 4) {
                    if (http_request.status == 200) {
						enab_dizab_save(this,0)
                    } else {
                        alert('There was a problem with the request ' + http_request.statusText);
                    }
                }

            }
            function enab_dizab_save(enab) {

                if (enab == 1) {
						document.getElementById('save').disabled=false;
						document.getElementById('save').style.color='#666';
                    } else {
						document.getElementById('save').disabled=true;
						document.getElementById('save').style.color='#CCC';
                    }
            }

            function row_led(obj_id1,obj_id2,enb) {
                if (enb == 1) {
						document.getElementById(obj_id1).style.backgroundColor = '#EEE';
						document.getElementById(obj_id2).style.backgroundColor = '#EEE';
                    } else {
						document.getElementById(obj_id1).style.backgroundColor = '#FFF';
						document.getElementById(obj_id2).style.backgroundColor = '#FFF';
                    }

            }

function spoiler_toggle(spoiler) {
    var sp_head_images = spoiler.parentNode.getElementsByTagName('div')[0].getElementsByTagName('images')[0];
    var sp_body = spoiler.parentNode.getElementsByTagName('div')[1];

    if (sp_body.style.display == 'none') {
        sp_body.style.display = 'block';
        sp_head_images.src =
            'images/icon_minus.gif';
    } else {
        sp_body.style.display = 'none';
        sp_head_images.src =
            'images/icon_plus.gif';
    }
}

    function bases_size() {
      var order = '';
      \$.post('get_size.cgi', order,function(TheResponse) {
	  if (TheResponse != '') {
	      \$("#bases_size").text(TheResponse);
	      \$("#clear_bases").removeAttr("disabled");
	      \$("#clear_bases").css('color','#666');
	  }
	  else
	  {
	      \$("#bases_size").text('-');
	      \$("#clear_bases").attr('disabled','disabled');
	      \$("#clear_bases").css('color','#CCC');
	  }
	  if ((\$("#progressbar").is(":visible"))) {
	      \$("#clear_bases").attr('disabled','disabled');
	      \$("#clear_bases").css('color','#CCC');
	  }
	});
      }

    function clear_bases_now() {
      var order = '';
      \$.post('clear.cgi', order,function(TheResponse) {
	  if (TheResponse == 'Ok') {
	      bases_size();
	    }
	  });
      }

    function update_bases() {
      var order = '';
      \$("#update_now").attr('disabled','disabled');
      \$("#update_now").css('color','#CCC');      
      \$.post('exec.cgi', order,function() {
	  });
      }      
      
    \$(function() {
    var progressbar = \$( "#progressbar" ),
      progressLabel = \$( ".progress-label" );
 
    progressbar.progressbar({
      value: false,
      change: function() {
        progressLabel.text( progressbar.progressbar( "value" ) + "%" );
      },
      complete: function() {
        \$('#progressbar').hide();
        \$('#update_info').show();
        document.location.reload();
      }
    });
    
    function progress() {

      var order = '';
      \$.post('progress.cgi', order,function(TheResponse) {
	  if (TheResponse != '') {
	    if (TheResponse == 'idle')
	    {
	      if ((\$("#progressbar").is(":visible"))) { document.location.reload();}
	      \$('#progressbar').hide();
	      \$('#update_info').show();
	      \$("#update_now").removeAttr("disabled");
	      \$("#update_now").css('color','#666');	      
	      progressbar.progressbar( "value", 0);
	    }
	    else
	    {
	      progressbar.progressbar( "value", parseFloat(TheResponse));
	      \$('#progressbar').show();
	      \$('#update_info').hide();
	      \$("#update_now").attr('disabled','disabled');
	      \$("#update_now").css('color','#CCC');
	    }
	  }
      });
        
        setTimeout( progress, 500 );
    }
 
    setTimeout( progress, 100 );
  });
  
  bases_size();
  setInterval('bases_size()',1000);
     
</script>
        
</head>

<body>
<span class="big_font">$lang_updStatTitle</span>
<hr />
<table width="100%" border="0">
  <tr>
    <td width="150"><span class="normal_font">$lang_dbCheck</span></td>
    <td><span class="bold_font" id="update_info" style="display: none">$nod_update</span><div id="progressbar" style="display: none"><div class="progress-label">0%</div></div></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_updTime</span></td>
    <td><span class="bold_font">$nod_ubdtime</span></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_updLast</span></td>
    <td><span class="bold_font">$nod_upbase</span></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_dbVer</span></td>
    <td><a class="bold_font" href="http://www.virusradar.com/en/update/info/$vers[0]" target="_blank">$nod_version</a></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_dbSize</span></td>
    <td><span class="bold_font" id="bases_size">-</span></td>
  </tr>
	$nod_error
 </table><br />
<span class="big_font">$lang_conftitle</span>
<hr />
<form id="options" name="options" method="post" action="index.cgi">
<table width="100%" border="0">
  <tr>
    <td width="150"><span class="normal_font">$lang_updUrl</span></td>
    <td><input type="text" name="nod_url" id="nod_url" value="$nod_url" title="$lang_updUrlDesc" onkeypress="enab_dizab_save(1)" /></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_nodUser</span></td>
    <td><input type="text" name="nod_user_name" id="nod_user_name" value="$nod_user" title="$lang_nodUserDesc" onkeypress="enab_dizab_save(1)" /></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_nodPsw</span></td>
    <td nowrap="nowrap"><input type="password" name="nod_usr_passwd" id="nod_usr_passwd" value="$nod_passwd" title="$lang_nodPswDesc" onkeypress="enab_dizab_save(1)" /><span class="passwd"  onmouseover="javascript:document.getElementById('nod_usr_passwd').type = 'text';" onmouseout="javascript:document.getElementById('nod_usr_passwd').type = 'password';">&lt; $lang_nodPswShow</span></td>
  </tr>
</table>
<div style="border-left: #c3cbd1 0px solid;
            padding:0px;
            width: 100%;
            margin: 10px auto;">
  <div style="background: #FFF;
              border: #c3cbd1 1px solid;
              padding: 2px;
              cursor: pointer;
              font-size: 12px" onclick="spoiler_toggle(this);">
    <img style="margin: 0px 3px;"
         src="images/icon_plus.gif"
         alt=""
         width="9" height="9" />
    <span>$lang_updSchedTitle</span>
  </div>

  <div style="display: none;
              background: #FFF;
              border: #c3cbd1 1px solid; border-top: 0;
              padding:2px;">
	<table width="100%" border="0">
		<tr>
			<td>
EOF
		for(my $i=0; $i<@weekgarr; $i++) {
			print "				<input class=\"checkbox\" type=\"checkbox\" name=\"week[]\" $weekgarr[$i][1] onClick=\"enab_dizab_save(1)\" /><span class=\"normal_font\" style=\"padding-right: 10px;\">$weekgarr[$i][0]</span>\n";
		}
		print "			</td>\n
		</tr>\n
		<tr>\n
			<td>\n
		<span class=\"normal_font\" style=\"padding: 10px;\">".$lang_dtTime." <select name=\"hours\" size=\"1\" style=\"width:40px\"  onClick=\"enab_dizab_save(1)\" />\n					<option>*</option>\n";
		for(my $i=0; $i<24; $i++) {
			if ($hours eq $i) {print "					<option selected=\"selected\">$i</option>\n";} else {print "					<option>$i</option>\n";}
		}
			print "				</select>&nbsp;&nbsp;:&nbsp;&nbsp;<select name=\"minutes\" size=\"1\" style=\"width:40px\"  onClick=\"enab_dizab_save(1)\">\n";
		for(my $i=0; $i<60; $i++) {
			if ($minutes == $i) {print "					<option selected=\"selected\">$i</option>\n";} else {print "					<option>$i</option>\n";}
		}
		print "				</span>\n";
print  <<EOF;
			</td>
		</tr>
	</table>
  </div>
</div>

<span class="big_font">$lang_locConfTitle</span>
<hr />
<table width="100%" border="0">
  <tr>
    <td width="150"><span class="normal_font">$lang_locFolder</span></td>
    <td><input type="text" name="nod_base" id="nod_base" value="$nod_bases" title="$lang_locFolderDesc" onkeypress="enab_dizab_save(1)" /></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_locUser</span></td>
    <td><input type="text" name="nod_usr_name_local" id="nod_usr_name_local" value="" title="$lang_locUserDesc" onkeypress="enab_dizab_save(1)" /></td>
  </tr>
  <tr>
    <td><span class="normal_font">$lang_locPsw</span></td>
    <td nowrap="nowrap"><input type="password" name="nod_usr_passwd_local" id="nod_usr_passwd_local" value="" title="$lang_locPswDesc" onkeypress="enab_dizab_save(1)" /></td>
<tr><td nowrap="nowrap"><span class="normal_font">$lang_locConfTitle2</span></td></tr>
  </tr>
  
EOF

  
  if (-s "$Bin/.htpasswd") {

print  <<EOF;
  
  <tr>
	<td></td>  
  </tr>
EOF

if ( ! open ( HTPASSWD , "$Bin/.htpasswd" ) )
{
   die ( "i cant open this file : $!" ); 
} 

   while ( $linea = <HTPASSWD> )
{
   @username = split ( ":" , $linea );
   
   print "<tr><td width='150'></td><td nowrap='nowrap' width='250' ><span class='bold_font'>@username[0]</span> </td><td><a href='index.cgi?usr_del=@username[0]'><span class='normal_font'>$lang_locdel</span></td></a></tr>";
}

} 
else
 {
 
print '<tr><td></td></tr>';
  
print "<td width='150'></td><td nowrap='nowrap'><span class='normal_font'> $lang_notlocuser </span> </td> </tr>"
 }

print  <<EOF; 

</table>
<div style="border-left: #c3cbd1 0px solid;
            padding:0px;
            width: 100%;
            margin: 10px auto;">
  <div style="background: #FFF;
              border: #c3cbd1 1px solid;
              padding: 2px;
              cursor: pointer;
              font-size: 12px" onclick="spoiler_toggle(this);">
    <img style="margin: 0px 3px;"
         src="images/icon_plus.gif"
         alt=""
         width="9" height="9" />
    <span>$lang_updLang</span>
  </div>

  <div style="display: none;
              background: #FFF;
              border: #c3cbd1 1px solid; border-top: 0;
              padding:2px;">
	<table width="100%" border="0">
		<tr>
EOF

my $n=-1;
for(my $i=0; $i<3; $i++) {
	print "		<td width=\"207\">\n";
	print "			<table width=\"100%\" border=\"0\" cellspacing=\"0\">\n";
		for(my $ii=0; $ii<8; $ii++) {
		$n++;
		print "				<tr><td id=\"td_lg_$n\" onmouseover=\"row_led('td_lg_$n','td_lg_ck_$n',1)\" onmouseout=\"row_led('td_lg_$n','td_lg_ck_$n',0)\"><span class=\"normal_font\">$langarr[$n][1]</span></td><td width=\"16\" id=\"td_lg_ck_$n\" onmouseover=\"row_led('td_lg_$n','td_lg_ck_$n',1)\" onmouseout=\"row_led('td_lg_$n','td_lg_ck_$n',0)\"><input class=\"checkbox\" type=\"checkbox\" name=\"lang[]\" $langarr[$n][2] onClick=\"enab_dizab_save(1)\" /></td></tr>\n";
		}
	print "			</table>\n";
	print "		</td>\n";
}

print  <<EOF;
		</tr>
	</table>
  </div>
</div>
<hr />
<input type="button" style="width:150px;height:23px;border-color:#666;color:#CCC;" disabled="disabled" name="save" id="save" value="$lang_cmdSave" onclick="makeRequest('save_setting.cgi')" />
<input type="button" style="width:150px;height:23px;border-color:#666;color:#CCC;" disabled="disabled" name="clear_bases" id="clear_bases" value="$lang_cmdClear" onclick="clear_bases_now()" />
<input type="button" style="width:150px;height:23px;border-color:#666;color:#CCC;" disabled="disabled" name="update_now" id="update_now" value="$lang_cmdUpdate" onclick="update_bases()" />
<span class="normal_font" style="text-align:left">
Version: $version | Updates: <a href="http://synologyitalia.com" target="_blank" style="color:#000">synologyitalia.com</a> | Original: <a href="http://www.diskstation.ru/viewtopic.php?f=31&t=193&start=130" target="_blank" style="color:#000">www.diskstation.ru</a></span>
</form>
</body>
</html>
EOF

sub get_key {
	my($key) = @_;
	foreach $lne (@lines) {
		if ($lne =~ /^$key\s*=\s*(.*)$/) {
			return "$1\n";
			last;
		}
	}
}