#!/bin/sh

DIRN=`dirname "$0"`

find $DIRN -name update.lock -type f -mmin +50 -delete

if [ -e "$DIRN/update.lock" ]; then
echo "Update is active... exit..."
exit 0;
fi

UPDATEFILE="update.ver"
UPDATEFILEEMPTY="update_empty.ver"
UPDATE_TIME=`date +"%d.%m.%Y %H:%M"`

echo "0" > $DIRN/update.lock

if [ -e "$DIRN/update.conf" ]; then
LOCALB=`"$DIRN/get_key_value.cgi" "$DIRN/update.conf" bases`
URL=`"$DIRN/get_key_value.cgi" "$DIRN/update.conf" url`
USER=`"$DIRN/get_key_value.cgi" "$DIRN/update.conf" user`
PASSWD=`"$DIRN/get_key_value.cgi" "$DIRN/update.conf" passwd`
MLANG=`"$DIRN/get_key_value.cgi" "$DIRN/update.conf" languages`
USER_AGENT="ESS Update (Windows; U; 32bit; PVT F; VDB 14275; BPC 5.0.2122.10; OS: 6.1.7601 SP 1.0 NT; TDB 14275; CL 1.1.1; LNG 1049; x32c; UPD ; APP eea; BEO 1; CPU 14156; ASP 0.10; FW 0.0; PX 0; PUA 1; CD 2)"


else
cat >$DIRN/lastupdate.info <<EOT
upbase=$UPDATE_BASE
update=$UPDATE_TIME
time= 0
version=$VERS
error=Cannot open $DIRN/update.conf
EOT
rm -f $DIRN/update.lock
exit 0;
fi

if [ -e "$DIRN/lastupdate.info" ]; then
LASTVERS=`"$DIRN/get_key_value.cgi" "$DIRN/lastupdate.info" version`
UPDATE_BASE=`"$DIRN/get_key_value.cgi" "$DIRN/lastupdate.info" upbase`
else
LASTVERS=""
UPDATE_BASE=$UPDATE_TIME
fi

WGET="wget --user=$USER --password=$PASSWD -t 15 -T 15 -N -nH -m -nd"

if [ ! -d $LOCALB ]; then
    mkdir -p $LOCALB
fi

TIME_START=`date +%s`

  cd /tmp
  rm -f $UPDATEFILE
  rm -f $UPDATEFILEEMPTY

echo "$WGET $URL/$UPDATEFILE"
CMD="$WGET $URL/$UPDATEFILE"
RESULTC=`$CMD 2>&1 | grep ERROR`

if [ $RESULTC ]; then
cat >$DIRN/lastupdate.info <<EOT
upbase=$UPDATE_BASE
update=$UPDATE_TIME
time= 0
version=$VERS
error=$RESULTC
EOT
rm -f $DIRN/update.lock
exit 0;
fi

if [ ! -e "/tmp/$UPDATEFILE" ]; then
cat >$DIRN/lastupdate.info <<EOT
upbase=$UPDATE_BASE
update=$UPDATE_TIME
time= 0
version=$VERS
error=Cannot connect to server $URL
EOT
rm -f $DIRN/update.lock
exit 0;
fi


if [ -n "`grep -i ^Rar $UPDATEFILE`" ]; then
  mv $UPDATEFILE $UPDATEFILE.tmp
  unrar x $UPDATEFILE.tmp ./
  rm -f $UPDATEFILE.tmp
  
if [ ! -e "/tmp/$UPDATEFILE" ]; then
cat >$DIRN/lastupdate.info <<EOT
upbase=$UPDATE_BASE
update=$UPDATE_TIME
time= 0
version=$VERS
error=Downloaded empty file =(
EOT
rm -f $DIRN/update.lock
exit 0;
fi
  URL=`echo $URL|sed -e 's/\/eset_upd\/v.\///g'`
else
  URL="$URL/"
fi

TMPFILE=/tmp/nod32.tmp
grep file= $UPDATEFILE > $TMPFILE
sed -i $MLANG $TMPFILE
sed -i 's/.$//' $TMPFILE

cd $LOCALB
echo "Delete old files..."
ALLFLIST=`ls | grep .nup$`

for FILED in $ALLFLIST; do
	FILENAMED=$(basename $FILED)
	if [ "`grep -i $FILENAMED $TMPFILE`" = "" ]; then
		echo "Deleting $FILENAMED"
		CMD="rm -f $FILENAMED"
		eval "$CMD" || exit 0;
	fi
done

FILELIST=`cut -c 6- $TMPFILE`
MAX=`wc -l $TMPFILE | awk '{print $1}'`
rm -f $TMPFILE

PROGRESS=0

echo "Downloading updates..."
for FILE in $FILELIST; do
	FILENAME=$(basename $FILE)
		CMD="$WGET $URL$FILE"
		echo "Downloading $FILENAME"
		echo "From $URL$FILE"
		RESULTC=`$CMD 2>&1`
		PROGRESS=`expr $PROGRESS + 1`
		echo "PROGRESS=$PROGRESS" > $DIRN/update.lock
		echo "MAX=$MAX" >> $DIRN/update.lock
done

cp /tmp/$UPDATEFILE $LOCALB/$UPDATEFILE
sed -e 's#\(^file=\)\(.*\)/\(.*\)#\1\3#' -i $LOCALB/$UPDATEFILE
TIME_STOP=`date +%s`
let "TIME_UPDATE=$TIME_STOP-$TIME_START"

VERS=`"$DIRN/get_key_value.cgi" "$LOCALB/$UPDATEFILE" ENGINE2 version`

if [ "$VERS" != "$LASTVERS" ]; then
	UPDATE_BASE=$UPDATE_TIME
fi

cat >$DIRN/lastupdate.info <<EOT
upbase=$UPDATE_BASE
update=$UPDATE_TIME
time=$TIME_UPDATE
version=$VERS
error=$TERROR
EOT

rm -f $DIRN/update.lock
echo "Done. Update time: $TIME_UPDATE s"
